export const formRules = () => {
	return [{
		field: 'deliveryName',
		label: '配送人',
		placeholder: '请选择配送人',
		type: 'selectiveSearch',
		required: true,
	}, {
		field: 'reCheckName',
		label: '复核人',
		placeholder: '请选择复核人',
		type: 'selectiveSearch',
		required: true,
	}, {
		field: 'is_secondary_distribution',
		label: '二次分配',
		placeholder: '是否二次分配',
		type: 'switch',
		required: true,
	}, {
		field: 'drugBarCode',
		label: '扫描药品条形码',
		placeholder: '请扫描药品条形码',
		type: 'drugBarCode',
		required: true,
		clearable: true,
	}, {
		type: 'divider',
	}, {
		field: 'prescription',
		label: '处方',
		placeholder: '请上传处方',
		type: 'upload',
		required: false,
		fileList1: [],
	}, {
		field: 'tamperProofLabel',
		label: '防拆标签码',
		placeholder: '请扫描防拆标签码',
		type: 'input',
		required: false,
		clearable: true,
	}, {
		field: 'tamperProofLabelImg',
		label: '防拆标签图片',
		placeholder: '请上传防拆标签图片',
		type: 'upload',
		required: false,
		fileList1: [],
	}, {
		field: 'remark',
		label: '备注',
		placeholder: '备注',
		type: 'textarea',
	}]
}

export const pickupRulesil = () => {
	return [{
		field: 'name',
		label: '姓名',
		placeholder: '请输入姓名',
		type: 'input',
		required: true,
	}, {
		field: 'phone',
		label: '电话',
		placeholder: '请输入电话',
		type: 'input',
		required: true,
	}, {
		field: 'address',
		label: '地址',
		placeholder: '请输入地址',
		type: 'input',
		required: true,
	}]
}
export const allocationRulesil = () => {
	return [{
		field: 'name',
		label: '姓名',
		placeholder: '请输入姓名',
		type: 'input',
		required: false,
	}, {
		field: 'phone',
		label: '电话',
		placeholder: '请输入电话',
		type: 'input',
		required: true,
	}, {
		field: 'address',
		label: '地址',
		placeholder: '请输入地址',
		type: 'input',
		required: false,
	}]
}
export const iceRaftRulesil = () => {
	return [{
		field: 'code',
		label: '编号',
		placeholder: '请输入编号',
		type: 'input',
		required: true,
	}, {
		field: 'label',
		label: '冰排备注',
		placeholder: '请输入冰排备注',
		type: 'input',
		required: false,
	}, {
		field: 'status',
		label: '状态',
		placeholder: '请选择状态',
		type: 'selectiveSearch',
		required: true,
		options: [{
			value: '2',
			label: '正常'
		}, {
			value: '1',
			label: '停用'
		}]
	}, {
		field: 'freezeClaim',
		label: '冷冻要求',
		placeholder: '请输入冷冻时间',
		type: 'selectiveSearch',
		required: true,
		options: [{
			label: '48小时',
			value: 48,
		}, {
			label: '24小时',
			value: 24,
		}, {
			label: '12小时',
			value: 12,
		}]
	}, {
		field: 'suitableForCold',
		label: '释冷温度',
		placeholder: '请输入释冷温度',
		type: 'input',
		required: false,
		unit: '℃',
	}, {
		field: 'forColdTime',
		label: '释冷要求',
		placeholder: '请输入释冷要求',
		type: 'input',
		required: false,
		unit: '小时',
	}, {
		field: 'iceColdAddress',
		label: '释冷地点',
		placeholder: '请输入释冷地点',
		type: 'input',
		required: false,
	}, {
		field: 'sort',
		label: '排序',
		placeholder: '请输入排序编号',
		type: 'input',
		required: false,
	}]
}
export const printList = () => {
	return [{
		field: 'name',
		label: '姓名',
		placeholder: '请输入姓名',
		type: 'input',
		required: true,
	}, {
		field: 'phone',
		label: '电话',
		placeholder: '请输入电话',
		type: 'input',
		required: true,
	}]
}
// 分配订单
export const allocationList = () => {
	return [{
		field: 'drugBarCode',
		label: '扫描药品条形码',
		placeholder: '请扫描药品条形码',
		type: 'drugBarCode',
		required: true,
		clearable: true,
	}, {
		type: 'divider',
	}, {
		field: 'prescription',
		label: '处方',
		placeholder: '请上传处方',
		type: 'upload',
		required: false,
		fileList1: [],
	}]
}